/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "frontend/parser.yy"

	#include "../structure/ast/ast.hpp"
	#include <iostream>
	#include <cstdlib>
	#include <string>
	#include <cstdio>

	AST::CompUnits *root;
	extern char *yytext;

	extern int yylex();
	extern int yyget_lineno();
	void yyerror(const char *s) { std::cerr << s << std::endl; exit(yytext[0]);}


#line 87 "frontend/parser.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_BREAK = 3,                      /* BREAK  */
  YYSYMBOL_CONTINUE = 4,                   /* CONTINUE  */
  YYSYMBOL_RETURN = 5,                     /* RETURN  */
  YYSYMBOL_WHILE = 6,                      /* WHILE  */
  YYSYMBOL_IF = 7,                         /* IF  */
  YYSYMBOL_ELSE = 8,                       /* ELSE  */
  YYSYMBOL_VOID = 9,                       /* VOID  */
  YYSYMBOL_FLOAT = 10,                     /* FLOAT  */
  YYSYMBOL_CONST = 11,                     /* CONST  */
  YYSYMBOL_INTT = 12,                      /* INTT  */
  YYSYMBOL_STARTTIME = 13,                 /* STARTTIME  */
  YYSYMBOL_STOPTIME = 14,                  /* STOPTIME  */
  YYSYMBOL_INTNUMBER = 15,                 /* INTNUMBER  */
  YYSYMBOL_ADDOP = 16,                     /* ADDOP  */
  YYSYMBOL_SUBOP = 17,                     /* SUBOP  */
  YYSYMBOL_LANDOP = 18,                    /* LANDOP  */
  YYSYMBOL_LOROP = 19,                     /* LOROP  */
  YYSYMBOL_NOTOP = 20,                     /* NOTOP  */
  YYSYMBOL_MULOP = 21,                     /* MULOP  */
  YYSYMBOL_EQUALOP = 22,                   /* EQUALOP  */
  YYSYMBOL_RELOP = 23,                     /* RELOP  */
  YYSYMBOL_FLOATNUMBER = 24,               /* FLOATNUMBER  */
  YYSYMBOL_FORMAT = 25,                    /* FORMAT  */
  YYSYMBOL_ID = 26,                        /* ID  */
  YYSYMBOL_prec1 = 27,                     /* prec1  */
  YYSYMBOL_prec2 = 28,                     /* prec2  */
  YYSYMBOL_29_ = 29,                       /* ';'  */
  YYSYMBOL_30_ = 30,                       /* ','  */
  YYSYMBOL_31_ = 31,                       /* '='  */
  YYSYMBOL_32_ = 32,                       /* '['  */
  YYSYMBOL_33_ = 33,                       /* ']'  */
  YYSYMBOL_34_ = 34,                       /* '{'  */
  YYSYMBOL_35_ = 35,                       /* '}'  */
  YYSYMBOL_36_ = 36,                       /* '('  */
  YYSYMBOL_37_ = 37,                       /* ')'  */
  YYSYMBOL_YYACCEPT = 38,                  /* $accept  */
  YYSYMBOL_COMPUNITS = 39,                 /* COMPUNITS  */
  YYSYMBOL_COMPUNIT = 40,                  /* COMPUNIT  */
  YYSYMBOL_DECL = 41,                      /* DECL  */
  YYSYMBOL_CONSTDECL = 42,                 /* CONSTDECL  */
  YYSYMBOL_CONSTDEFS = 43,                 /* CONSTDEFS  */
  YYSYMBOL_BTYPE = 44,                     /* BTYPE  */
  YYSYMBOL_CONSTDEF = 45,                  /* CONSTDEF  */
  YYSYMBOL_VARDECL = 46,                   /* VARDECL  */
  YYSYMBOL_VARDEFS = 47,                   /* VARDEFS  */
  YYSYMBOL_VARDEF = 48,                    /* VARDEF  */
  YYSYMBOL_ARR_INDEX = 49,                 /* ARR_INDEX  */
  YYSYMBOL_INITVAL = 50,                   /* INITVAL  */
  YYSYMBOL_ARR_INIT = 51,                  /* ARR_INIT  */
  YYSYMBOL_INITVALS = 52,                  /* INITVALS  */
  YYSYMBOL_FUNCDEF = 53,                   /* FUNCDEF  */
  YYSYMBOL_PARAMETERS = 54,                /* PARAMETERS  */
  YYSYMBOL_PARAMETER = 55,                 /* PARAMETER  */
  YYSYMBOL_BLOCK = 56,                     /* BLOCK  */
  YYSYMBOL_BLOCKITEMS = 57,                /* BLOCKITEMS  */
  YYSYMBOL_BLOCKITEM = 58,                 /* BLOCKITEM  */
  YYSYMBOL_STMT = 59,                      /* STMT  */
  YYSYMBOL_ASSIGNSTMT = 60,                /* ASSIGNSTMT  */
  YYSYMBOL_EXPSTMT = 61,                   /* EXPSTMT  */
  YYSYMBOL_IFSTMT = 62,                    /* IFSTMT  */
  YYSYMBOL_WHILESTMT = 63,                 /* WHILESTMT  */
  YYSYMBOL_BREAKSTMT = 64,                 /* BREAKSTMT  */
  YYSYMBOL_CONTINUESTMT = 65,              /* CONTINUESTMT  */
  YYSYMBOL_RETURNSTMT = 66,                /* RETURNSTMT  */
  YYSYMBOL_STARTTIMESTMT = 67,             /* STARTTIMESTMT  */
  YYSYMBOL_STOPTIMESTMT = 68,              /* STOPTIMESTMT  */
  YYSYMBOL_EXP = 69,                       /* EXP  */
  YYSYMBOL_IDEXP = 70,                     /* IDEXP  */
  YYSYMBOL_LVAL = 71,                      /* LVAL  */
  YYSYMBOL_PRIMARYEXP = 72,                /* PRIMARYEXP  */
  YYSYMBOL_NUMBER = 73,                    /* NUMBER  */
  YYSYMBOL_UNARYEXP = 74,                  /* UNARYEXP  */
  YYSYMBOL_CALLEXP = 75,                   /* CALLEXP  */
  YYSYMBOL_UNARYOP = 76,                   /* UNARYOP  */
  YYSYMBOL_EXPS = 77,                      /* EXPS  */
  YYSYMBOL_MULEXP = 78,                    /* MULEXP  */
  YYSYMBOL_ADDEXP = 79,                    /* ADDEXP  */
  YYSYMBOL_RELEXP = 80,                    /* RELEXP  */
  YYSYMBOL_EQEXP = 81,                     /* EQEXP  */
  YYSYMBOL_LANDEXP = 82,                   /* LANDEXP  */
  YYSYMBOL_LOREXP = 83,                    /* LOREXP  */
  YYSYMBOL_FORMATEXP = 84                  /* FORMATEXP  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  13
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   229

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  38
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  47
/* YYNRULES -- Number of rules.  */
#define YYNRULES  93
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  150

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   283


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      36,    37,     2,     2,    30,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    29,
       2,    31,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    32,     2,    33,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    34,     2,    35,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   113,   113,   120,   128,   131,   136,   139,   145,   150,
     153,   158,   160,   162,   166,   171,   175,   178,   183,   185,
     189,   191,   196,   198,   202,   206,   208,   210,   215,   219,
     221,   223,   228,   230,   239,   243,   245,   250,   252,   256,
     258,   260,   262,   264,   266,   268,   270,   272,   274,   276,
     280,   284,   288,   290,   294,   298,   302,   306,   308,   312,
     316,   320,   322,   324,   326,   328,   330,   332,   334,   336,
     338,   342,   346,   350,   352,   354,   358,   360,   364,   368,
     373,   375,   377,   381,   383,   385,   390,   394,   396,   400,
     404,   408,   412,   416
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "BREAK", "CONTINUE",
  "RETURN", "WHILE", "IF", "ELSE", "VOID", "FLOAT", "CONST", "INTT",
  "STARTTIME", "STOPTIME", "INTNUMBER", "ADDOP", "SUBOP", "LANDOP",
  "LOROP", "NOTOP", "MULOP", "EQUALOP", "RELOP", "FLOATNUMBER", "FORMAT",
  "ID", "prec1", "prec2", "';'", "','", "'='", "'['", "']'", "'{'", "'}'",
  "'('", "')'", "$accept", "COMPUNITS", "COMPUNIT", "DECL", "CONSTDECL",
  "CONSTDEFS", "BTYPE", "CONSTDEF", "VARDECL", "VARDEFS", "VARDEF",
  "ARR_INDEX", "INITVAL", "ARR_INIT", "INITVALS", "FUNCDEF", "PARAMETERS",
  "PARAMETER", "BLOCK", "BLOCKITEMS", "BLOCKITEM", "STMT", "ASSIGNSTMT",
  "EXPSTMT", "IFSTMT", "WHILESTMT", "BREAKSTMT", "CONTINUESTMT",
  "RETURNSTMT", "STARTTIMESTMT", "STOPTIMESTMT", "EXP", "IDEXP", "LVAL",
  "PRIMARYEXP", "NUMBER", "UNARYEXP", "CALLEXP", "UNARYOP", "EXPS",
  "MULEXP", "ADDEXP", "RELEXP", "EQEXP", "LANDEXP", "LOREXP", "FORMATEXP", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-84)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     132,   -84,   -84,    63,   -84,    48,   -84,   -84,   -84,   -16,
     -84,   -84,   -16,   -84,   -84,   -84,     9,   -84,   -25,    34,
     -84,   -84,   -84,   -16,    63,    -4,   -84,   -16,    67,   -84,
     -84,   -16,   -21,   -84,    54,   160,   -84,    54,   -14,    63,
     -10,   -84,   -84,   -84,   -84,   -84,   -84,    54,   160,   -84,
     -84,   206,    15,   -84,   -84,   -84,   -84,   -84,   160,   -84,
     -84,   -84,   -84,   -84,   -84,   -84,   193,   -84,   -13,   -84,
     -84,   -84,   -84,    19,    13,   160,   160,   160,   160,   160,
     160,   160,   160,    21,   -84,   -84,   -84,   111,    54,   -84,
     -84,    45,    45,    60,    85,   -84,    -9,    70,   206,   -11,
      21,   -84,   -84,   160,    53,    64,   -84,   -84,   -84,   -84,
     -84,   -16,   -84,   -84,   -84,    26,    55,   -84,   -84,    82,
      83,    90,   100,   101,   206,   102,   -84,   160,   -84,   206,
     160,   160,   -84,   -84,   -84,   -84,   -84,   -84,   -84,   160,
     206,   171,   181,   206,   145,   145,   -84,   124,   145,   -84
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,    13,    12,     0,    11,     0,     3,     4,     6,     0,
       7,     5,     0,     1,     2,    71,     0,    16,    20,     0,
       9,    20,    15,     0,    29,    18,     8,     0,     0,    17,
      20,     0,     0,    30,     0,     0,    10,     0,    32,     0,
       0,    76,    80,    81,    82,    77,    93,    25,     0,    19,
      23,    22,    20,    74,    61,    75,    62,    69,     0,    63,
      64,    65,    66,    67,    68,    70,     0,    14,     0,    31,
      35,    28,    26,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    83,    72,    78,    21,    20,     0,     0,    24,
      73,    87,    88,    91,    92,    86,    90,    89,    84,     0,
      33,    55,    56,    57,     0,     0,    59,    60,    40,    34,
      37,     0,    42,    36,    38,     0,     0,    43,    44,     0,
       0,     0,     0,     0,    51,    74,    27,     0,    79,    58,
       0,     0,    39,    41,    45,    46,    47,    48,    49,     0,
      85,     0,     0,    50,     0,     0,    54,    52,     0,    53
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -84,   -84,   129,    51,   -84,   -84,    -2,   112,   -84,   -84,
     130,   -19,   -32,   -84,   -84,   -84,   -84,   115,   116,   -84,
     -84,   -51,   -84,   -84,   -84,   -84,   -84,   -84,   -84,   -84,
     -84,   -35,    -6,   -83,   -84,   -84,   -84,   -84,   -84,   -84,
     -84,   -84,   -84,   -84,   -84,   -84,   -84
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     5,     6,     7,     8,    19,     9,    20,    10,    16,
      17,    25,    49,    50,    73,    11,    32,    33,   112,    87,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,    51,    52,    53,    54,    55,    56,    57,    58,    99,
      59,    60,    61,    62,    63,    64,    65
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      66,    12,    28,    18,   125,    67,    21,    75,    76,    39,
      15,    24,    79,    74,    81,    72,    40,    30,    68,   127,
      86,    21,    31,    84,    70,    38,   128,    34,    35,    75,
      76,    77,    78,    83,    79,    80,    81,    31,    22,    23,
      91,    92,    93,    94,    95,    96,    97,    98,    13,    88,
      90,    82,   124,    35,    89,   132,   126,     1,     2,     3,
       4,   125,   125,    26,    27,   125,    79,   100,   129,    41,
      42,    43,     1,     2,    44,     4,    75,    76,    45,    46,
      15,    79,    80,    81,   133,   111,    75,    76,    47,   130,
      48,    79,   140,   146,   147,   141,   142,   149,    37,    35,
     131,    75,    76,    77,   143,    30,    79,    80,    81,   124,
     124,   134,   135,   124,   101,   102,   103,   104,   105,   136,
       1,     2,     3,     4,   106,   107,    41,    42,    43,   137,
     138,    44,   148,   139,    14,    45,    46,    15,   110,    36,
     108,     1,     2,     3,     4,    70,   109,    48,   101,   102,
     103,   104,   105,    29,    69,     0,    71,     0,   106,   107,
      41,    42,    43,     0,     0,    44,     0,     0,     0,    45,
      46,    15,     0,     0,   108,    41,    42,    43,     0,    70,
      44,    48,     0,     0,    45,    46,    15,    75,    76,    77,
      78,     0,    79,    80,    81,     0,    48,    75,    76,    77,
      78,     0,    79,    80,    81,     0,     0,     0,   144,    75,
      76,    77,    78,     0,    79,    80,    81,     0,   145,     0,
       0,     0,    75,    76,    77,    78,    85,    79,    80,    81
};

static const yytype_int16 yycheck[] =
{
      35,     3,    21,     9,    87,    37,    12,    16,    17,    30,
      26,    36,    21,    48,    23,    47,    37,    23,    32,    30,
      33,    27,    24,    58,    34,    31,    37,    31,    32,    16,
      17,    18,    19,    52,    21,    22,    23,    39,    29,    30,
      75,    76,    77,    78,    79,    80,    81,    82,     0,    30,
      37,    36,    87,    32,    35,    29,    88,     9,    10,    11,
      12,   144,   145,    29,    30,   148,    21,    86,   103,    15,
      16,    17,     9,    10,    20,    12,    16,    17,    24,    25,
      26,    21,    22,    23,    29,    87,    16,    17,    34,    36,
      36,    21,   127,   144,   145,   130,   131,   148,    31,    32,
      36,    16,    17,    18,   139,   111,    21,    22,    23,   144,
     145,    29,    29,   148,     3,     4,     5,     6,     7,    29,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    29,
      29,    20,     8,    31,     5,    24,    25,    26,    87,    27,
      29,     9,    10,    11,    12,    34,    35,    36,     3,     4,
       5,     6,     7,    23,    39,    -1,    40,    -1,    13,    14,
      15,    16,    17,    -1,    -1,    20,    -1,    -1,    -1,    24,
      25,    26,    -1,    -1,    29,    15,    16,    17,    -1,    34,
      20,    36,    -1,    -1,    24,    25,    26,    16,    17,    18,
      19,    -1,    21,    22,    23,    -1,    36,    16,    17,    18,
      19,    -1,    21,    22,    23,    -1,    -1,    -1,    37,    16,
      17,    18,    19,    -1,    21,    22,    23,    -1,    37,    -1,
      -1,    -1,    16,    17,    18,    19,    33,    21,    22,    23
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     9,    10,    11,    12,    39,    40,    41,    42,    44,
      46,    53,    44,     0,    40,    26,    47,    48,    70,    43,
      45,    70,    29,    30,    36,    49,    29,    30,    49,    48,
      70,    44,    54,    55,    31,    32,    45,    31,    70,    30,
      37,    15,    16,    17,    20,    24,    25,    34,    36,    50,
      51,    69,    70,    71,    72,    73,    74,    75,    76,    78,
      79,    80,    81,    82,    83,    84,    69,    50,    32,    55,
      34,    56,    50,    52,    69,    16,    17,    18,    19,    21,
      22,    23,    36,    49,    69,    33,    33,    57,    30,    35,
      37,    69,    69,    69,    69,    69,    69,    69,    69,    77,
      49,     3,     4,     5,     6,     7,    13,    14,    29,    35,
      41,    44,    56,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    71,    50,    30,    37,    69,
      36,    36,    29,    29,    29,    29,    29,    29,    29,    31,
      69,    69,    69,    69,    37,    37,    59,    59,     8,    59
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    38,    39,    39,    40,    40,    41,    41,    42,    43,
      43,    44,    44,    44,    45,    46,    47,    47,    48,    48,
      49,    49,    50,    50,    51,    52,    52,    52,    53,    54,
      54,    54,    55,    55,    56,    57,    57,    58,    58,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      60,    61,    62,    62,    63,    64,    65,    66,    66,    67,
      68,    69,    69,    69,    69,    69,    69,    69,    69,    69,
      69,    70,    71,    72,    72,    72,    73,    73,    74,    75,
      76,    76,    76,    77,    77,    77,    78,    79,    79,    80,
      81,    82,    83,    84
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     1,     1,     1,     1,     1,     4,     1,
       3,     1,     1,     1,     4,     3,     1,     3,     2,     4,
       0,     4,     1,     1,     3,     0,     1,     3,     6,     0,
       1,     3,     2,     5,     3,     0,     2,     1,     1,     2,
       1,     2,     1,     1,     1,     2,     2,     2,     2,     2,
       3,     1,     5,     7,     5,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     1,     1,     1,     1,     2,     4,
       1,     1,     1,     0,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* COMPUNITS: COMPUNITS COMPUNIT  */
#line 113 "frontend/parser.yy"
                              {
	/* CompUnits -> CompUnits CompUnit */
	(yyval.root) = (yyvsp[-1].root);
	(yyval.root)->list.push_back((yyvsp[0].compunit));

	root = (yyval.root);

}
#line 1286 "frontend/parser.cpp"
    break;

  case 3: /* COMPUNITS: COMPUNIT  */
#line 120 "frontend/parser.yy"
             {
	/* CompUnits -> CompUnit */
	(yyval.root) = new AST::CompUnits(yyget_lineno());
	(yyval.root)->list.push_back((yyvsp[0].compunit));
	
	root = (yyval.root);
}
#line 1298 "frontend/parser.cpp"
    break;

  case 4: /* COMPUNIT: DECL  */
#line 128 "frontend/parser.yy"
                {
	/* CompUnit -> Decl */
	(yyval.compunit) = static_cast<AST::CompUnit *>((yyvsp[0].decl));
}
#line 1307 "frontend/parser.cpp"
    break;

  case 5: /* COMPUNIT: FUNCDEF  */
#line 131 "frontend/parser.yy"
            {
	/* CompUint -> FuncDef */
	(yyval.compunit) = static_cast<AST::CompUnit *>((yyvsp[0].funcdef));
}
#line 1316 "frontend/parser.cpp"
    break;

  case 6: /* DECL: CONSTDECL  */
#line 136 "frontend/parser.yy"
                {
	/* Decl -> ConstDecl */
	(yyval.decl) = static_cast<AST::Decl *>((yyvsp[0].constdecl));
}
#line 1325 "frontend/parser.cpp"
    break;

  case 7: /* DECL: VARDECL  */
#line 139 "frontend/parser.yy"
            {
	/* Decl -> VarDecl */
	(yyval.decl) = static_cast<AST::Decl *>((yyvsp[0].vardecl));
}
#line 1334 "frontend/parser.cpp"
    break;

  case 8: /* CONSTDECL: CONST BTYPE CONSTDEFS ';'  */
#line 145 "frontend/parser.yy"
                                     {
	/* ConstDecl -> const Btype ConstDef (, ConstDef)* ; */
	(yyval.constdecl) = new AST::ConstDecl((yyvsp[-2].btype), (yyvsp[-1].constdefs), yyget_lineno());
}
#line 1343 "frontend/parser.cpp"
    break;

  case 9: /* CONSTDEFS: CONSTDEF  */
#line 150 "frontend/parser.yy"
                    {
	(yyval.constdefs) = new AST::ConstDefs(yyget_lineno());
	(yyval.constdefs)->list.push_back((yyvsp[0].constdef));
}
#line 1352 "frontend/parser.cpp"
    break;

  case 10: /* CONSTDEFS: CONSTDEFS ',' CONSTDEF  */
#line 153 "frontend/parser.yy"
                           {
	(yyval.constdefs) = (yyvsp[-2].constdefs);
	(yyvsp[-2].constdefs)->list.push_back((yyvsp[0].constdef));
}
#line 1361 "frontend/parser.cpp"
    break;

  case 11: /* BTYPE: INTT  */
#line 158 "frontend/parser.yy"
            {
	(yyval.btype) = AST::btype_t::INT;
}
#line 1369 "frontend/parser.cpp"
    break;

  case 12: /* BTYPE: FLOAT  */
#line 160 "frontend/parser.yy"
          {
	(yyval.btype) = AST::btype_t::FLOAT;
}
#line 1377 "frontend/parser.cpp"
    break;

  case 13: /* BTYPE: VOID  */
#line 162 "frontend/parser.yy"
         {
	(yyval.btype) = AST::btype_t::VOID;
}
#line 1385 "frontend/parser.cpp"
    break;

  case 14: /* CONSTDEF: IDEXP ARR_INDEX '=' INITVAL  */
#line 166 "frontend/parser.yy"
                                      {
	/* ConstDef -> ID ( [Exp] )* = InitVal */
	(yyval.constdef) = new AST::ConstDef((yyvsp[-3].idexp), (yyvsp[-2].arr_index), (yyvsp[0].initval), yyget_lineno());
}
#line 1394 "frontend/parser.cpp"
    break;

  case 15: /* VARDECL: BTYPE VARDEFS ';'  */
#line 171 "frontend/parser.yy"
                           {
	(yyval.vardecl) = new AST::VarDecl((yyvsp[-2].btype), (yyvsp[-1].vardefs), yyget_lineno());
}
#line 1402 "frontend/parser.cpp"
    break;

  case 16: /* VARDEFS: VARDEF  */
#line 175 "frontend/parser.yy"
                {
	(yyval.vardefs) = new AST::VarDefs(yyget_lineno());
	(yyval.vardefs)->list.push_back((yyvsp[0].vardef));
}
#line 1411 "frontend/parser.cpp"
    break;

  case 17: /* VARDEFS: VARDEFS ',' VARDEF  */
#line 178 "frontend/parser.yy"
                       {
	(yyval.vardefs) = (yyvsp[-2].vardefs);
	(yyval.vardefs)->list.push_back((yyvsp[0].vardef));
}
#line 1420 "frontend/parser.cpp"
    break;

  case 18: /* VARDEF: IDEXP ARR_INDEX  */
#line 183 "frontend/parser.yy"
                        {
	(yyval.vardef) = new AST::VarDef((yyvsp[-1].idexp), (yyvsp[0].arr_index), nullptr, yyget_lineno());
}
#line 1428 "frontend/parser.cpp"
    break;

  case 19: /* VARDEF: IDEXP ARR_INDEX '=' INITVAL  */
#line 185 "frontend/parser.yy"
                                {
	(yyval.vardef) = new AST::VarDef((yyvsp[-3].idexp), (yyvsp[-2].arr_index), (yyvsp[0].initval), yyget_lineno());
}
#line 1436 "frontend/parser.cpp"
    break;

  case 20: /* ARR_INDEX: %empty  */
#line 189 "frontend/parser.yy"
            {
	(yyval.arr_index) = new AST::Arr_Index(yyget_lineno());
}
#line 1444 "frontend/parser.cpp"
    break;

  case 21: /* ARR_INDEX: ARR_INDEX '[' EXP ']'  */
#line 191 "frontend/parser.yy"
                          {
	(yyval.arr_index) = (yyvsp[-3].arr_index);
	(yyval.arr_index)->list.push_back((yyvsp[-1].exp));
}
#line 1453 "frontend/parser.cpp"
    break;

  case 22: /* INITVAL: EXP  */
#line 196 "frontend/parser.yy"
             {
	(yyval.initval) = (yyvsp[0].exp);
}
#line 1461 "frontend/parser.cpp"
    break;

  case 23: /* INITVAL: ARR_INIT  */
#line 198 "frontend/parser.yy"
             {
	(yyval.initval) = (yyvsp[0].arr_init);
}
#line 1469 "frontend/parser.cpp"
    break;

  case 24: /* ARR_INIT: '{' INITVALS '}'  */
#line 202 "frontend/parser.yy"
                           {
	(yyval.arr_init) = (yyvsp[-1].initvals);
}
#line 1477 "frontend/parser.cpp"
    break;

  case 25: /* INITVALS: %empty  */
#line 206 "frontend/parser.yy"
          {
	(yyval.initvals) = new AST::InitVals(yyget_lineno());
}
#line 1485 "frontend/parser.cpp"
    break;

  case 26: /* INITVALS: INITVAL  */
#line 208 "frontend/parser.yy"
            {
	(yyval.initvals) = new AST::InitVals((yyvsp[0].initval), yyget_lineno());
}
#line 1493 "frontend/parser.cpp"
    break;

  case 27: /* INITVALS: INITVALS ',' INITVAL  */
#line 210 "frontend/parser.yy"
                         {
	(yyval.initvals) = (yyvsp[-2].initvals);
	(yyval.initvals)->list.push_back((yyvsp[0].initval));
}
#line 1502 "frontend/parser.cpp"
    break;

  case 28: /* FUNCDEF: BTYPE IDEXP '(' PARAMETERS ')' BLOCK  */
#line 215 "frontend/parser.yy"
                                              {
	(yyval.funcdef) = new AST::FuncDef((yyvsp[-5].btype), (yyvsp[-4].idexp), (yyvsp[-2].parameters), (yyvsp[0].block), yyget_lineno());
}
#line 1510 "frontend/parser.cpp"
    break;

  case 29: /* PARAMETERS: %empty  */
#line 219 "frontend/parser.yy"
             {
	(yyval.parameters) = new AST::Parameters(yyget_lineno());
}
#line 1518 "frontend/parser.cpp"
    break;

  case 30: /* PARAMETERS: PARAMETER  */
#line 221 "frontend/parser.yy"
              {
	(yyval.parameters) = new AST::Parameters((yyvsp[0].parameter), yyget_lineno());
}
#line 1526 "frontend/parser.cpp"
    break;

  case 31: /* PARAMETERS: PARAMETERS ',' PARAMETER  */
#line 223 "frontend/parser.yy"
                             {
	(yyval.parameters) = (yyvsp[-2].parameters);
	(yyval.parameters)->list.push_back((yyvsp[0].parameter));
}
#line 1535 "frontend/parser.cpp"
    break;

  case 32: /* PARAMETER: BTYPE IDEXP  */
#line 228 "frontend/parser.yy"
                       {
	(yyval.parameter) = new AST::Parameter((yyvsp[-1].btype), (yyvsp[0].idexp), new AST::Arr_Index(yyget_lineno()), yyget_lineno());
}
#line 1543 "frontend/parser.cpp"
    break;

  case 33: /* PARAMETER: BTYPE IDEXP '[' ']' ARR_INDEX  */
#line 230 "frontend/parser.yy"
                                  {
	auto x = new AST::Arr_Index(yyget_lineno());
	x->list.push_back(new AST::IntNumber(1, yyget_lineno()));
	for (const auto &y:(yyvsp[0].arr_index)->list) {
		x->list.push_back(y);
	}
	(yyval.parameter) = new AST::Parameter((yyvsp[-4].btype), (yyvsp[-3].idexp), x, yyget_lineno());
}
#line 1556 "frontend/parser.cpp"
    break;

  case 34: /* BLOCK: '{' BLOCKITEMS '}'  */
#line 239 "frontend/parser.yy"
                          {
	(yyval.block) = new AST::Block((yyvsp[-1].blockitems), yyget_lineno());
}
#line 1564 "frontend/parser.cpp"
    break;

  case 35: /* BLOCKITEMS: %empty  */
#line 243 "frontend/parser.yy"
             {
	(yyval.blockitems) = new AST::BlockItems(yyget_lineno());
}
#line 1572 "frontend/parser.cpp"
    break;

  case 36: /* BLOCKITEMS: BLOCKITEMS BLOCKITEM  */
#line 245 "frontend/parser.yy"
                         {
	(yyval.blockitems) = (yyvsp[-1].blockitems);
	(yyval.blockitems)->list.push_back((yyvsp[0].blockitem));
}
#line 1581 "frontend/parser.cpp"
    break;

  case 37: /* BLOCKITEM: DECL  */
#line 250 "frontend/parser.yy"
                {
	(yyval.blockitem) = (yyvsp[0].decl);
}
#line 1589 "frontend/parser.cpp"
    break;

  case 38: /* BLOCKITEM: STMT  */
#line 252 "frontend/parser.yy"
         {
	(yyval.blockitem) = (yyvsp[0].stmt);
}
#line 1597 "frontend/parser.cpp"
    break;

  case 39: /* STMT: ASSIGNSTMT ';'  */
#line 256 "frontend/parser.yy"
                     {
	(yyval.stmt) = (yyvsp[-1].stmt);
}
#line 1605 "frontend/parser.cpp"
    break;

  case 40: /* STMT: ';'  */
#line 258 "frontend/parser.yy"
        {
	(yyval.stmt) = new AST::ExpStmt(new AST::IntNumber(0, yyget_lineno()), yyget_lineno());
}
#line 1613 "frontend/parser.cpp"
    break;

  case 41: /* STMT: EXPSTMT ';'  */
#line 260 "frontend/parser.yy"
                {
	(yyval.stmt) = (yyvsp[-1].stmt);
}
#line 1621 "frontend/parser.cpp"
    break;

  case 42: /* STMT: BLOCK  */
#line 262 "frontend/parser.yy"
          {
	(yyval.stmt) = (yyvsp[0].block);
}
#line 1629 "frontend/parser.cpp"
    break;

  case 43: /* STMT: IFSTMT  */
#line 264 "frontend/parser.yy"
           {
	(yyval.stmt) = (yyvsp[0].stmt);
}
#line 1637 "frontend/parser.cpp"
    break;

  case 44: /* STMT: WHILESTMT  */
#line 266 "frontend/parser.yy"
              {
	(yyval.stmt) = (yyvsp[0].stmt);
}
#line 1645 "frontend/parser.cpp"
    break;

  case 45: /* STMT: BREAKSTMT ';'  */
#line 268 "frontend/parser.yy"
                  {
	(yyval.stmt) = (yyvsp[-1].stmt);
}
#line 1653 "frontend/parser.cpp"
    break;

  case 46: /* STMT: CONTINUESTMT ';'  */
#line 270 "frontend/parser.yy"
                     {
	(yyval.stmt) = (yyvsp[-1].stmt);
}
#line 1661 "frontend/parser.cpp"
    break;

  case 47: /* STMT: RETURNSTMT ';'  */
#line 272 "frontend/parser.yy"
                   {
	(yyval.stmt) = (yyvsp[-1].stmt);
}
#line 1669 "frontend/parser.cpp"
    break;

  case 48: /* STMT: STARTTIMESTMT ';'  */
#line 274 "frontend/parser.yy"
                      {
	(yyval.stmt) = (yyvsp[-1].stmt);
}
#line 1677 "frontend/parser.cpp"
    break;

  case 49: /* STMT: STOPTIMESTMT ';'  */
#line 276 "frontend/parser.yy"
                     {
	(yyval.stmt) = (yyvsp[-1].stmt);
}
#line 1685 "frontend/parser.cpp"
    break;

  case 50: /* ASSIGNSTMT: LVAL '=' EXP  */
#line 280 "frontend/parser.yy"
                         {
	(yyval.stmt) = new AST::AssignStmt((yyvsp[-2].lval), (yyvsp[0].exp), yyget_lineno());
}
#line 1693 "frontend/parser.cpp"
    break;

  case 51: /* EXPSTMT: EXP  */
#line 284 "frontend/parser.yy"
             {
	(yyval.stmt) = new AST::ExpStmt((yyvsp[0].exp), yyget_lineno());
}
#line 1701 "frontend/parser.cpp"
    break;

  case 52: /* IFSTMT: IF '(' EXP ')' STMT  */
#line 288 "frontend/parser.yy"
                                        {
	(yyval.stmt) = new AST::IfStmt((yyvsp[-2].exp), (yyvsp[0].stmt), nullptr, yyget_lineno());
}
#line 1709 "frontend/parser.cpp"
    break;

  case 53: /* IFSTMT: IF '(' EXP ')' STMT ELSE STMT  */
#line 290 "frontend/parser.yy"
                                  {
	(yyval.stmt) = new AST::IfStmt((yyvsp[-4].exp), (yyvsp[-2].stmt), (yyvsp[0].stmt), yyget_lineno());
}
#line 1717 "frontend/parser.cpp"
    break;

  case 54: /* WHILESTMT: WHILE '(' EXP ')' STMT  */
#line 294 "frontend/parser.yy"
                                  {
	(yyval.stmt) = new AST::WhileStmt((yyvsp[-2].exp), (yyvsp[0].stmt), yyget_lineno());
}
#line 1725 "frontend/parser.cpp"
    break;

  case 55: /* BREAKSTMT: BREAK  */
#line 298 "frontend/parser.yy"
                 {
	(yyval.stmt) = new AST::BreakStmt(yyget_lineno());
}
#line 1733 "frontend/parser.cpp"
    break;

  case 56: /* CONTINUESTMT: CONTINUE  */
#line 302 "frontend/parser.yy"
                       {
	(yyval.stmt) = new AST::ContinueStmt(yyget_lineno());
}
#line 1741 "frontend/parser.cpp"
    break;

  case 57: /* RETURNSTMT: RETURN  */
#line 306 "frontend/parser.yy"
                   {
	(yyval.stmt) = new AST::ReturnStmt(nullptr, yyget_lineno());
}
#line 1749 "frontend/parser.cpp"
    break;

  case 58: /* RETURNSTMT: RETURN EXP  */
#line 308 "frontend/parser.yy"
               {
	(yyval.stmt) = new AST::ReturnStmt((yyvsp[0].exp), yyget_lineno());
}
#line 1757 "frontend/parser.cpp"
    break;

  case 59: /* STARTTIMESTMT: STARTTIME  */
#line 312 "frontend/parser.yy"
                         {
	(yyval.stmt) = new AST::StarttimeStmt(yyget_lineno());
}
#line 1765 "frontend/parser.cpp"
    break;

  case 60: /* STOPTIMESTMT: STOPTIME  */
#line 316 "frontend/parser.yy"
                       {
	(yyval.stmt) = new AST::StoptimeStmt(yyget_lineno());
}
#line 1773 "frontend/parser.cpp"
    break;

  case 61: /* EXP: PRIMARYEXP  */
#line 320 "frontend/parser.yy"
                {
	(yyval.exp) = (yyvsp[0].exp);
}
#line 1781 "frontend/parser.cpp"
    break;

  case 62: /* EXP: UNARYEXP  */
#line 322 "frontend/parser.yy"
             {
	(yyval.exp) = (yyvsp[0].exp);
}
#line 1789 "frontend/parser.cpp"
    break;

  case 63: /* EXP: MULEXP  */
#line 324 "frontend/parser.yy"
           {
	(yyval.exp) = (yyvsp[0].exp);
}
#line 1797 "frontend/parser.cpp"
    break;

  case 64: /* EXP: ADDEXP  */
#line 326 "frontend/parser.yy"
           {
	(yyval.exp) = (yyvsp[0].exp);
}
#line 1805 "frontend/parser.cpp"
    break;

  case 65: /* EXP: RELEXP  */
#line 328 "frontend/parser.yy"
           {
	(yyval.exp) = (yyvsp[0].exp);
}
#line 1813 "frontend/parser.cpp"
    break;

  case 66: /* EXP: EQEXP  */
#line 330 "frontend/parser.yy"
          {
	(yyval.exp) = (yyvsp[0].exp);
}
#line 1821 "frontend/parser.cpp"
    break;

  case 67: /* EXP: LANDEXP  */
#line 332 "frontend/parser.yy"
            {
	(yyval.exp) = (yyvsp[0].exp);
}
#line 1829 "frontend/parser.cpp"
    break;

  case 68: /* EXP: LOREXP  */
#line 334 "frontend/parser.yy"
           {
	(yyval.exp) = (yyvsp[0].exp);
}
#line 1837 "frontend/parser.cpp"
    break;

  case 69: /* EXP: CALLEXP  */
#line 336 "frontend/parser.yy"
            {
	(yyval.exp) = (yyvsp[0].exp);
}
#line 1845 "frontend/parser.cpp"
    break;

  case 70: /* EXP: FORMATEXP  */
#line 338 "frontend/parser.yy"
              {
	(yyval.exp) = (yyvsp[0].exp);
}
#line 1853 "frontend/parser.cpp"
    break;

  case 71: /* IDEXP: ID  */
#line 342 "frontend/parser.yy"
          {
	(yyval.idexp) = new AST::IdExp((yyvsp[0].id), yyget_lineno());
}
#line 1861 "frontend/parser.cpp"
    break;

  case 72: /* LVAL: IDEXP ARR_INDEX  */
#line 346 "frontend/parser.yy"
                      {
	(yyval.lval) = new AST::Lval((yyvsp[-1].idexp), (yyvsp[0].arr_index), yyget_lineno());
}
#line 1869 "frontend/parser.cpp"
    break;

  case 73: /* PRIMARYEXP: '(' EXP ')'  */
#line 350 "frontend/parser.yy"
                        {
	(yyval.exp) = (yyvsp[-1].exp);
}
#line 1877 "frontend/parser.cpp"
    break;

  case 74: /* PRIMARYEXP: LVAL  */
#line 352 "frontend/parser.yy"
         {
	(yyval.exp) = (yyvsp[0].lval);
}
#line 1885 "frontend/parser.cpp"
    break;

  case 75: /* PRIMARYEXP: NUMBER  */
#line 354 "frontend/parser.yy"
           {
	(yyval.exp) = (yyvsp[0].number);
}
#line 1893 "frontend/parser.cpp"
    break;

  case 76: /* NUMBER: INTNUMBER  */
#line 358 "frontend/parser.yy"
                  {
	(yyval.number) = new AST::IntNumber((yyvsp[0].token), yyget_lineno());
}
#line 1901 "frontend/parser.cpp"
    break;

  case 77: /* NUMBER: FLOATNUMBER  */
#line 360 "frontend/parser.yy"
                {
	(yyval.number) = new AST::FloatNumber((yyvsp[0].floatnumber), yyget_lineno());
}
#line 1909 "frontend/parser.cpp"
    break;

  case 78: /* UNARYEXP: UNARYOP EXP  */
#line 364 "frontend/parser.yy"
                                  {
	(yyval.exp) = new AST::UnaryExp((yyvsp[-1].unaryop), (yyvsp[0].exp), yyget_lineno());
}
#line 1917 "frontend/parser.cpp"
    break;

  case 79: /* CALLEXP: IDEXP '(' EXPS ')'  */
#line 368 "frontend/parser.yy"
                            {
	(yyval.exp) = new AST::CallExp((yyvsp[-3].idexp), (yyvsp[-1].exps), yyget_lineno());
}
#line 1925 "frontend/parser.cpp"
    break;

  case 80: /* UNARYOP: ADDOP  */
#line 373 "frontend/parser.yy"
               {
	(yyval.unaryop) = AST::unary_op_t::ADD;
}
#line 1933 "frontend/parser.cpp"
    break;

  case 81: /* UNARYOP: SUBOP  */
#line 375 "frontend/parser.yy"
          {
	(yyval.unaryop) = AST::unary_op_t::SUB;
}
#line 1941 "frontend/parser.cpp"
    break;

  case 82: /* UNARYOP: NOTOP  */
#line 377 "frontend/parser.yy"
          {
	(yyval.unaryop) = AST::unary_op_t::NOT;
}
#line 1949 "frontend/parser.cpp"
    break;

  case 83: /* EXPS: %empty  */
#line 381 "frontend/parser.yy"
       {
	(yyval.exps) = new AST::Exps(yyget_lineno());
}
#line 1957 "frontend/parser.cpp"
    break;

  case 84: /* EXPS: EXP  */
#line 383 "frontend/parser.yy"
        {
	(yyval.exps) = new AST::Exps((yyvsp[0].exp), yyget_lineno());
}
#line 1965 "frontend/parser.cpp"
    break;

  case 85: /* EXPS: EXPS ',' EXP  */
#line 385 "frontend/parser.yy"
                 {
	(yyval.exps) = (yyvsp[-2].exps);
	(yyval.exps)->list.push_back((yyvsp[0].exp));
}
#line 1974 "frontend/parser.cpp"
    break;

  case 86: /* MULEXP: EXP MULOP EXP  */
#line 390 "frontend/parser.yy"
                      {
	(yyval.exp) = new AST::MulExp((yyvsp[-2].exp), (yyvsp[-1].mul), (yyvsp[0].exp), yyget_lineno());
}
#line 1982 "frontend/parser.cpp"
    break;

  case 87: /* ADDEXP: EXP ADDOP EXP  */
#line 394 "frontend/parser.yy"
                      {
	(yyval.exp) = new AST::AddExp((yyvsp[-2].exp), AST::add_op_t::ADD, (yyvsp[0].exp), yyget_lineno());
}
#line 1990 "frontend/parser.cpp"
    break;

  case 88: /* ADDEXP: EXP SUBOP EXP  */
#line 396 "frontend/parser.yy"
                  {
	(yyval.exp) = new AST::AddExp((yyvsp[-2].exp), AST::add_op_t::SUB, (yyvsp[0].exp), yyget_lineno());
}
#line 1998 "frontend/parser.cpp"
    break;

  case 89: /* RELEXP: EXP RELOP EXP  */
#line 400 "frontend/parser.yy"
                      {
	(yyval.exp) = new AST::RelExp((yyvsp[-2].exp), (yyvsp[-1].rel), (yyvsp[0].exp), yyget_lineno());
}
#line 2006 "frontend/parser.cpp"
    break;

  case 90: /* EQEXP: EXP EQUALOP EXP  */
#line 404 "frontend/parser.yy"
                       {
	(yyval.exp) = new AST::EqExp((yyvsp[-2].exp), (yyvsp[-1].equal), (yyvsp[0].exp), yyget_lineno());
}
#line 2014 "frontend/parser.cpp"
    break;

  case 91: /* LANDEXP: EXP LANDOP EXP  */
#line 408 "frontend/parser.yy"
                        {
	(yyval.exp) = new AST::LAndExp((yyvsp[-2].exp), (yyvsp[0].exp), yyget_lineno());
}
#line 2022 "frontend/parser.cpp"
    break;

  case 92: /* LOREXP: EXP LOROP EXP  */
#line 412 "frontend/parser.yy"
                      {
	(yyval.exp) = new AST::LOrExp((yyvsp[-2].exp), (yyvsp[0].exp), yyget_lineno());
}
#line 2030 "frontend/parser.cpp"
    break;

  case 93: /* FORMATEXP: FORMAT  */
#line 416 "frontend/parser.yy"
                  {
	(yyval.exp) = new AST::FormatExp((yyvsp[0].format), yyget_lineno());
}
#line 2038 "frontend/parser.cpp"
    break;


#line 2042 "frontend/parser.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 420 "frontend/parser.yy"

