#pragma once
#include <iostream>
#include "graph.hpp"
#include "../../structure/mir/mir.hpp"

namespace cfg {
using std::list;

class BlockGraph;

class BlockGraph: public Graph {
public:
    BlockGraph(mir::Block* block);
    Node *entry, *exit;

    void show();
private:
    Node* lookup(mir::StmList* b);
    void enter(mir::StmList* b1, mir::StmList* b2);
};


};