#include "../ssa/build_ssa.hpp"
namespace ssa{

//simple constant propagation
class ReverseGraph: public cfg::Graph{
public:
    ReverseGraph(NodeList* nodelist);
    void show();
    DomiTable domi;
};
class ControlDependenceGraph: public cfg::Graph{
public:
    ControlDependenceGraph(NodeList* nodelist, Node* exitnode)
    :nodelist(nodelist)
    ,exitnode(exitnode){
        build();
        show();
    }
    void build();
    void show();

    NodeList* nodelist;
    Node* entrynode;
    Node* exitnode;
};

void test_cdg();
}//namespace ssa