#include "../ssa/build_ssa.hpp"
namespace ssa{
enum class TempStatus{
    Undifined,
    Const,
    Temp
};
//simple constant propagation
class ConstPropagation{
public:
ConstPropagation(NodeList* nodelist):nodelist(nodelist){
    scp();
}
void scp();
std::pair<bool, mir::Const*> is_const(mir::Exp* exp);
NodeList* nodelist;
std::unordered_map<utils::Temp*, TempStatus> temp_status;
std::unordered_map<utils::Temp*, mir::Const*> temp_const;
std::unordered_map<utils::Temp*, std::list<mir::Stm**>> use_stm;
std::set<mir::Stm**> delete_stm;
};

}//namespace ssa