#pragma once
#include "../ssa/build_ssa.hpp"
namespace ssa{
class Loop {
public:
    Loop(NodeList* ir);
    void findLoop();
    struct LoopInfo {
        bool canUnroll, isConst;
        int step, times;
        Uexp begin, end;
        int inducetemp;
    };
    LoopInfo analyse(int loopHead);
    bool loopUnroll();
    std::pair<bool, std::pair<Uexp, int>> findCircle(int block, int temp);
    NodeList* ir;
    
    std::map<int, std::set<int>> loops;
    std::set<int> doneloop;
    std::vector<int> parent;
};



};